"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
let idx = 0;
function default_1({ types: t }) {
    return {
        visitor: {
            Program: {
                enter(path, state) {
                    path.traverse({
                        ImportDeclaration(path, state) {
                            const source = path.node.source.value;
                            if (source !== 'next/amp')
                                return;
                            state.hasAmp = true;
                        },
                    }, state);
                }
            },
            CallExpression(path, state) {
                if (!state.hasAmp || state.insertedDrop)
                    return;
                // @ts-ignore
                if (path.node.callee.name !== 'withAmp')
                    return;
                if (path.node.arguments.length > 1) {
                    if (!t.isObjectExpression(path.node.arguments[1]))
                        return;
                    // @ts-ignore
                    const options = path.node.arguments[1];
                    // make sure it isn't a hybrid page e.g. hybrid: true
                    if (options.properties.some((prop) => {
                        if (!t.isObjectProperty(prop))
                            return false;
                        if (prop.key.name !== 'hybrid' || !t.isBooleanLiteral(prop.value)) {
                            return false;
                        }
                        // found hybrid: true
                        return Boolean(prop.value.value);
                    })) {
                        return;
                    }
                }
                // use random number and an increment to make sure HMR still updates
                idx++;
                state.insertedDrop = true;
                path.replaceWith(t.expressionStatement(t.stringLiteral(`throw new Error('__NEXT_DROP_CLIENT_FILE__' + ${Math.random() + idx})`)));
            }
        }
    };
}
exports.default = default_1;
